<!DOCTYPE html>
<html lang="en">

<head>
    <title>document</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <h1 class="mb-5 mt-5 text-center">DANH SÁCH NGƯỜI DÙNG </h1>
    <div class="container jumbotron">
        <div class="row">
            <div class="col-sm-2">
                <label for="">Name</label>
            </div>
            <div class="col-sm-8">
                <input id="ipn-name-user-loc" class="form-control" type="text" placeholder="name user cần lọc">
            </div>
            <div class="col-sm-2">
                <button id="btn-loc-user" class="btn btn-success">Lọc User</button>

            </div>


        </div>
    </div>
    <div class="container-fluid text-center">
        <table id="table-user" class="table table-striped table-hover table-bordered ">
            <thead>
                <tr class="table-primary">
                    <th>STT</th>
                    <th>Name</th>
                    <th>Username</th>
                    <th>Email</th>
                    <th>Address</th>
                    <th>Zip code</th>
                    <th>Phone</th>
                    <th>Company</th>
                    <th>Acction</th>
                </tr>
            </thead>
            <tbody class="table-info">
                <tr>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                    <td>No Data...</td>
                </tr>
            </tbody>
        </table>
    </div>

</body>
<script>
    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gObjectUserData = null;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        //khai báo nút lọc user 
        $("#btn-loc-user").click(onLocUserClick);
    });


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        console.log("đã load onpage loading ");
        // Gọi api và đổ dưx liệu lên bảng 
        getAllUsers();
    }
    function onChiTietClick() {
        var vId = $(this).data("id");
        console.log($(this).data("id"));
        var vUrl = "userDetail.html" +
            "?id=" + vId;
        window.location.href = vUrl;
    }
    // khai báo nút lọc user name 
    function onLocUserClick() {
        console.log("đã ấn nút lọc ");
        // b1 read data 
        var vUserName = getReadData();
        //b2 validate data
        var vResult = getValidateDataUserName(vUserName)
        if (vResult) {
            console.log(vUserName);
            console.log(gObjectUserData);
            // b3 lọc và  
            var vArrUser  = getShowAndFilter(gObjectUserData, vUserName);
            //b4 hiển thị ra bảng
            getLoadDataTable(vArrUser);
        }
    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // ...........................phần xử lý onpage loading
    // Mẫu gọi API - Get all users
    function getAllUsers() {
        //base url
        const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";
        $.ajax({
            url: vBASE_URL,
            dataType: "json",
            type: "GET",
            success: getLoadDataTable,
            error: function () {
                alert(ajaxContext.responseText);
            }
        });
    }
    function getLoadDataTable(paramRes) {
        console.log(paramRes);
        //gán dữ liệu nhận về vào biến toàn cục 
        gObjectUserData = paramRes;
        // làm trắng phần body
        $("#table-user tbody").html("");
        for (var bI = 0; bI < paramRes.length; bI++) {
            const vObjectUser = paramRes[bI];
            // tạo hàng mới 
            var vRowNew = $("<tr>").appendTo($("#table-user tbody"));
            vRowNew.append($("<td>", { html: bI + 1 }))
                .append($("<td>", { html: vObjectUser.name }))
                .append($("<td>", { html: vObjectUser.username }))
                .append($("<td>", { html: vObjectUser.email }))
                .append($("<td>", { html: vObjectUser.address.street + "<br>" + vObjectUser.address.suite + "<br>" + vObjectUser.address.city }))
                .append($("<td>", { html: vObjectUser.address.zipcode }))
                .append($("<td>", { html: vObjectUser.phone }))
                .append($("<td>", { html: vObjectUser.company.name }));
            //  xử lý cột button td
            var vColButton = $("<td>").appendTo(vRowNew);
            // xử lý nút button   
            $("<button>").addClass("btn btn-success")
                .data("id", vObjectUser.id)
                .html("Chi Tiết")
                .appendTo(vColButton)
                .click(onChiTietClick); // thêm sư kiện cho nút
        }
    }
    // /..................... [phần xử lý nút lọc user name]........................
    //b1
    function getReadData(paramObject) {
        var vUser = "";
        return vUser = $("#ipn-name-user-loc").val().trim();
    }
    // b2 
    function getValidateDataUserName(paramA) {
        if (paramA == "") {
            alert("Hãy nhâp user name");
            return false;
        }
        return true;
    }
    // b3 lọc và hiển thị ra table
    function getShowAndFilter(paramObject, paramUserName) {
        // vòng lặp để lọc 
        const vOBJCET = paramObject;
        const result = vOBJCET.filter(checkAdult);
        function checkAdult(paramOb) {
            //return paramOb.name === paramUserName;
            var vStringObject = JSON.stringify(paramOb);  // chuyển object thành JSON string
            return paramOb.name.toLowerCase().indexOf(paramUserName.toLowerCase()) > -1 ||
            vStringObject.toLowerCase().indexOf(paramUserName.toLowerCase()) > -1;   // tìm từ khóa theo JSON string
        }
        return result;
    }
</script>

</html>